function onclick_addnotify()
	
	print( "onclick_addnotify" )
	--
	dkcalframework.editControl.editNeedShowing = true
	
	local data = xdata:new()
	data.SetStr( "unionid", "" )
	if string.len(dkcalframework.editControl.editSegmentText) > 0 then
		data.SetStr( "content", dkcalframework.editControl.editSegmentText )
		data.SetStr( "color", dkcalframework.editControl.editSegmentColor )
		data.SetVBool( "strike", dkcalframework.editControl.editSegmentStrike )
	else
		data.SetStr( "content", "" )
	end
	framework.window.showModelessDialog2( 'dkcalconfig:\\frame.xml|NotifyEditor', data );

	dkcalframework.editControl.editNeedShowing = false
	
end

function onclick_deleteevent()

	local oReferrdata = document.referrerData
	if oReferrdata ~= nil and string.len(oReferrdata.GetStr( "unionid" )) > 0 then
		strUnionId = oReferrdata.GetStr( "unionid" )
		eventservice.DeleteRecurrence( strUnionId )
		dkcalframework.editControl.editCalEvent.DeleteEventItem( strUnionId )
	end
	
	window.close()

end

function getDateTextByLang( text )
	
	local curLang = framework.systemLanguage
	local oDatatime = datetime:new()
	oDatatime.ParamDateTime( text )
	
	local retText = text;
	
	if curLang == 'kor' then
		retText = oDatatime.GetFormat( '%Y/%m/%d' )
	elseif curLang == 'usa' then
		retText = oDatatime.GetFormat( '%m/%d/%Y' )
	elseif curLang == 'rus' then
		retText = oDatatime.GetFormat( '%m/%d/%Y' )
	elseif curLang == 'chs' and curLang == 'cht' then
		retText = oDatatime.GetFormat( '%Y-%m-%d' )
	else
		retText = oDatatime.GetFormat( '%Y/%m/%d' )
	end
	
	return retText;
end

function resetEditMarkComplete()

	local oContentText = document.getElementById( "recurrence_content" )
	local oEComplete = document.getElementById( "event_completed" )
	local oFont = oContentText.font
	
	if oEComplete.check then
		oFont.strikeout = true
	else
		oFont.strikeout = false
	end
	oContentText.font = oFont
	
end

function initRecurrenceCombo(oEventItem)

	local oComboRecurrence = document.getElementById( "recurrence_combo" )
	oComboRecurrence.minWidth = 200
	if 0 == oComboRecurrence.GetItemCount() then 
	
		local oEditCalEvent = dkcalframework.editControl.editCalEvent
		local strCurDay = oEditCalEvent.curEventDay
		print( strCurDay )
		
		local oDatatime = datetime:new()
		oDatatime.ParamDateTime( strCurDay )

		local oNewItem = comboboxitem:new()
		oNewItem.text = eventservice.GetRecurrenceComboText(oDatatime, 1, 0)
		oComboRecurrence.AddItem( oNewItem )

		local oNewItem = comboboxitem:new()
		oNewItem.text = eventservice.GetRecurrenceComboText(oDatatime, 1, 1)
		oComboRecurrence.AddItem( oNewItem )
		
		oNewItem = comboboxitem:new()
		oNewItem.text = eventservice.GetRecurrenceComboText(oDatatime, 1, 5)
		oComboRecurrence.AddItem( oNewItem )
		
		oNewItem = comboboxitem:new()
		oNewItem.text = eventservice.GetRecurrenceComboText(oDatatime, 1, 2)
		oComboRecurrence.AddItem( oNewItem )
		
		oNewItem = comboboxitem:new()
		oNewItem.text = eventservice.GetRecurrenceComboText(oDatatime, 1, 3)
		oComboRecurrence.AddItem( oNewItem )
		
		oNewItem = comboboxitem:new()
		oNewItem.text = eventservice.GetRecurrenceComboText(oDatatime, 1, 6)
		oComboRecurrence.AddItem( oNewItem )

		oNewItem = comboboxitem:new()
		oNewItem.text = eventservice.GetRecurrenceComboText(oDatatime, 1, 7)
		oComboRecurrence.AddItem( oNewItem )

		oNewItem = comboboxitem:new()
		oNewItem.text = eventservice.GetRecurrenceComboText(oDatatime, 1, 4)
		oComboRecurrence.AddItem( oNewItem )

		local curLang = framework.systemLanguage
		local lunarInvalid = 1
		if curLang == 'chs' or curLang == 'cht' or curLang == 'kor' or curLang == 'jpn' then
			lunarInvalid = 0
			oNewItem = comboboxitem:new()
			oNewItem.text = eventservice.GetRecurrenceComboText(oDatatime, 2, 4)
			oComboRecurrence.AddItem( oNewItem )	
		end

		oNewItem = comboboxitem:new()
		oNewItem.text = eventservice.GetRecurrenceComboText(oDatatime, 1, 8)
		oComboRecurrence.AddItem( oNewItem )

		oNewItem = comboboxitem:new()
		oNewItem.text = eventservice.GetRecurrenceComboText(oDatatime, 1, 9)
		oComboRecurrence.AddItem( oNewItem )


		if oEventItem ~= nil then
			local strRecurrence = oEventItem.recurrence
			local strFreq = oEventItem.freq
			local nRCount = oEventItem.recurrenceCount

			if( strRecurrence == "DAILY" and nRCount == 1) then
				oComboRecurrence.SetCurSel( 0 )
			elseif( strRecurrence == "DAILY" ) then
				oComboRecurrence.SetCurSel( 1 )
			elseif( strRecurrence == "WORKDAYLY" ) then 
				oComboRecurrence.SetCurSel( 2 )
			elseif( strRecurrence == "WEEKLY" ) then 
				oComboRecurrence.SetCurSel( 3 )
			elseif( strRecurrence == "MONTHLY" ) then 
				oComboRecurrence.SetCurSel( 4 )
			elseif( strRecurrence == "MONTHLASTDAYLY" ) then 
				oComboRecurrence.SetCurSel( 5 )
			elseif( strRecurrence == "SEASONLY" ) then 
				oComboRecurrence.SetCurSel( 6 )
			elseif( strRecurrence == "YEARLY" ) then 
				oComboRecurrence.SetCurSel( 7 )
			elseif( strRecurrence == "CUSTOMDAY" ) then
				oComboRecurrence.SetCurSel( 9 - lunarInvalid )
			elseif( strRecurrence == "CUSTOMWEEK" ) then 
				oComboRecurrence.SetCurSel( 10- lunarInvalid )
			end

			if( strFreq == 'lunar' and lunarInvalid == 0) then
				oComboRecurrence.SetCurSel( 8 )
			end
		else
			oComboRecurrence.SetCurSel( 0 )
		end
	end

	local oComboCustomCount = document.getElementById( "custom_count_combo" )
	if 0 == oComboCustomCount.GetItemCount() then 

		for i=1, 100 do
			local oNewItem = comboboxitem:new()
			oNewItem.text = string.format( "%d", i )
			oComboCustomCount.AddItem( oNewItem )
		end


		if oEventItem ~= nil then
			local customCount = oEventItem.customCount

			if( customCount > 0 ) then
				oComboCustomCount.SetCurSel( customCount - 1 )
			else
				oComboCustomCount.SetCurSel( 0 )
			end
		else
			oComboCustomCount.SetCurSel( 0 )
		end

		local nType = getRecurrenceType()
		if nType == 8 or nType == 9 then
			oComboCustomCount.style.display = ''
		else
			oComboCustomCount.style.display = 'none'
		end
	end
	
	local oSETime = document.getElementById( "select_end_time" )
	local oRETimes = document.getElementById( "edit_recurrencetimes" )
	oSETime.minWidth = 113

	local oComboRecurrenceTime = document.getElementById( "recurrence_time_combo" )
	oComboRecurrenceTime.minWidth = 200
	if 0 == oComboRecurrenceTime.GetItemCount() then 
	
		local oNewItem = comboboxitem:new()
		oNewItem.text = language.GetStringById( 'IDS_EVENTEDITOR_RECURRENCE_INTERVAL' )
		oComboRecurrenceTime.AddItem( oNewItem )

		oNewItem = comboboxitem:new()
		oNewItem.text = language.GetStringById( 'IDS_EVENTEDITOR_END_TIME' )
		oComboRecurrenceTime.AddItem( oNewItem )

		oNewItem = comboboxitem:new()
		oNewItem.text = language.GetStringById( 'IDS_EVENTEDITOR_RECURRENCE_TIMES' )
		oComboRecurrenceTime.AddItem( oNewItem )


		if oEventItem ~= nil then
			local nRCount = oEventItem.recurrenceCount
			local strRUntil = oEventItem.recurrenceUntil

			if( nRCount ~= -1 ) then
				oSETime.style.display = 'none'

				oRETimes.text = string.format( "%d", nRCount )
				oComboRecurrenceTime.SetCurSel( 2 )

			elseif( string.len(strRUntil) > 0 ) then 
				oRETimes.style.display = 'none'

				oSETime.name = strRUntil
				oSETime.text = getDateTextByLang( strRUntil )
				oComboRecurrenceTime.SetCurSel( 1 )

			else
				oRETimes.style.display = 'none'
				oSETime.style.display = 'none'
				oComboRecurrenceTime.SetCurSel( 0 )
			end

		else
			oSETime.style.display = 'none'

			oComboRecurrenceTime.SetCurSel( 2 )
		end
	end


	local nIndex = oComboRecurrence.GetCurSel()

	if nIndex == 0 then
		oRETimes.disabled = 'true'
		oRETimes.text = '1'
		oComboRecurrenceTime.SetCurSel(2)
		oComboRecurrenceTime.disabled = 'true'
	else 
		oRETimes.disabled = 'false'
		oComboRecurrenceTime.disabled = 'false'
	end
end

function initNotificaionCombo( oTriggerTime )

	local oComboNotifyHour = document.getElementById( "event_notify_hour" )
	local oComboNotifyMinute = document.getElementById( "event_notify_minute" )

	if 0 == oComboNotifyHour.GetItemCount() and 0 == oComboNotifyMinute.GetItemCount() then 

		local oComboFont = font:new()
		oComboFont.facename = 'verdana'
		oComboFont.pointsize = 9
		oComboNotifyHour.style.font = oComboFont
		oComboNotifyMinute.style.font = oComboFont

		for i=0, 23 do
			local oNewItem = comboboxitem:new()
			oNewItem.text = string.format( "%d", i )
			oComboNotifyHour.AddItem( oNewItem )
		end

		for i=0, 59 do
			local oNewItem = comboboxitem:new()
			oNewItem.text = string.format( "%.2d", i )
			oComboNotifyMinute.AddItem( oNewItem )
		end
		
		local nCurHour = 0
		local nCurMinute = 0
		
		if oTriggerTime ~= nil then
			nCurHour = oTriggerTime.triggerHour
			nCurMinute = oTriggerTime.triggerMinute
		else
			nCurHour = tonumber(os.date("%H"))
			nCurMinute = tonumber(os.date("%M"))

			nCurHour = nCurHour + math.floor((nCurMinute + 15) / 60)
			nCurHour = nCurHour % 24
			nCurMinute = math.floor(((nCurMinute + 15) % 60) / 15) * 15

			print (nCurHour)
			print (nCurMinute)
		end

		oComboNotifyHour.SetCurSel( nCurHour )
		oComboNotifyMinute.SetCurSel( nCurMinute )
	end

	
	
	local oComboNotifyDay = document.getElementById( "event_notify_day" )
	oComboNotifyDay.minWidth = 200
	
	if 0 == oComboNotifyDay.GetItemCount() then 
	
		local oEditCalEvent = dkcalframework.editControl.editCalEvent
		local strCurDay = oEditCalEvent.curEventDay
		print( strCurDay )
		
		local oDatatime = datetime:new()
		oDatatime.ParamDateTime( strCurDay )

		local oNewItem = comboboxitem:new()
		oNewItem.text = eventservice.GetNotifyDayComboText(oDatatime, 0)
		oComboNotifyDay.AddItem( oNewItem )
		
		oNewItem = comboboxitem:new()
		oNewItem.text = eventservice.GetNotifyDayComboText(oDatatime, -1)
		oComboNotifyDay.AddItem( oNewItem )
		
		oNewItem = comboboxitem:new()
		oNewItem.text = eventservice.GetNotifyDayComboText(oDatatime, -2)
		oComboNotifyDay.AddItem( oNewItem )
		
		oNewItem = comboboxitem:new()
		oNewItem.text = eventservice.GetNotifyDayComboText(oDatatime, -3)
		oComboNotifyDay.AddItem( oNewItem )
		
		
		
		if oTriggerTime ~= nil then
			local nDay = oTriggerTime.triggerDay
			if nDay == -1 then 
				oComboNotifyDay.SetCurSel( 1 )
			elseif nDay == -2 then 
				oComboNotifyDay.SetCurSel( 2 )
			elseif nDay == -3 then 
				oComboNotifyDay.SetCurSel( 3 )
			else
				oComboNotifyDay.SetCurSel( 0 )
			end
		else		
			oComboNotifyDay.SetCurSel( 0 )
		end
	
	end
end

function onload_notifyeditor()
	
	print( "onload_notifyeditor" )
	
	
	local curLang = framework.systemLanguage
	
	if curLang ~= 'chs' then
		document.getElementById( "event_notify_wechat" ).style.display = 'none'
	end
	
	local oEditCalEvent = dkcalframework.editControl.editCalEvent
	local strCurDay = oEditCalEvent.curEventDay
	local oCurDatetime = datetime:new()
	oCurDatetime.ParamDateTime( strCurDay )

	local oTitleText = document.getElementById( "EventEditorTitle" )
	oTitleText.text = eventservice.GetEvnetTitleText('IDS_EVENTEDITOR_TITLE_NOTIFY', oCurDatetime)
	
	local oReferrdata = document.referrerData
	if oReferrdata ~= nil and string.len(oReferrdata.GetStr( "unionid" )) > 0 then
		
		strUnionId = oReferrdata.GetStr( "unionid" )
		
		local oContentText = document.getElementById( "recurrence_content" )
		local oEventItem = eventservice.GetEventItemByUnionId( strUnionId, oCurDatetime )
		
		local oContent = oEventItem.content
		if oContent ~= nil then
			
			local strContent = oContent.mkText
			local strRecurrence = oEventItem.recurrence
			local strFreq = oEventItem.freq
			local nRCount = oEventItem.recurrenceCount
			local strRUntil = oEventItem.recurrenceUntil
			local bMarkComplete = oEventItem.markComplete
			local oNotifyObj = oEventItem.notifyObj
			local sPublishSubsId = oEventItem.publishSubsId
			local strTextColor = oContent.mkTextColor
			
			
			
			oContentText.text = strContent
			if string.len(strTextColor) > 0 then
				oContentText.editTextColor = makedata.BSTRCOLORREF3(strTextColor)
			end 
			oContentText.SetSel( 0, string.len(strContent) )
			
			initRecurrenceCombo(oEventItem)

			
			document.getElementById( "event_completed" ).check = bMarkComplete
			
			
			
			if oNotifyObj and oNotifyObj.checkNotify then
				document.getElementById( "event_notification" ).check = true
				document.getElementById( "event_notify_wechat" ).check = oNotifyObj.notifyWechat
				initNotificaionCombo( oNotifyObj.triggerTime )
			else
				initNotificaionCombo( nil )
			end
			
			
			if string.len(sPublishSubsId) > 0 then 
				
				local oSubsEventCombo = document.getElementById( "subs_event_combo" );
				local oSubsCreateList = subservice.GetSubsCreateList()
				
				local nSetSelect = -1;
				for i=0, oSubsCreateList.GetCount()-1 do
					local oData = oSubsCreateList.GetData(i)
					
					local oNewItem = comboboxitem:new()
					oNewItem.text = oData.GetStr("sname")
					oNewItem.data = oData
					oSubsEventCombo.AddItem( oNewItem )
					
					if oData.GetStr("smid") == sPublishSubsId then
						nSetSelect = i
					end
				end
				
				if oSubsEventCombo.GetItemCount() > 0 and nSetSelect >= 0 then 
					oSubsEventCombo.SetCurSel(nSetSelect)
					
					document.getElementById( "subs_event" ).check = true
					document.getElementById( "subs_event_create" ).style.display = ''
					oSubsEventCombo.style.display = ''
				end
				
			else
				document.getElementById( "subs_event" ).check = false
			end
		end
		
	else
		if oReferrdata ~= nil and string.len(oReferrdata.GetStr( "content" )) > 0 then
			local strContent = oReferrdata.GetStr( "content" )
			local bMarkComplete = oReferrdata.GetVBool( "strike" )
			local strTextColor = oReferrdata.GetStr("color")
			local oContentText = document.getElementById( "recurrence_content" )
			oContentText.text = strContent
			if string.len(strTextColor) > 0 then
				oContentText.editTextColor = makedata.BSTRCOLORREF3(strTextColor)
			end 
			oContentText.SetSel( 0, string.len(strContent) )
			document.getElementById( "event_completed" ).check = bMarkComplete
		end

		initRecurrenceCombo(nil)
		initNotificaionCombo( nil )
		
		window.xSetWindowPos( 0, 0, dpi.GetDpiLenth(400), dpi.GetDpiLenth(540), 2 )
		--document.getElementById( "editor_notify_container" ).style.display = 'none'
		
	end


	resetEditMarkComplete()
	
	
	subservice.onupdatecomplete = makedata.MakeEvent2( "dkcalconfig:subs_func.lua|oncallback_subs_data", this )

	dkcalframework.eventEditorShow = true
end

g_queryUserInfo = nil

function onunload_notifyeditor()
	print( 'onunload_notifyeditor' )
	if g_queryUserInfo ~= nil then
		g_queryUserInfo.killTimer()
		g_queryUserInfo = nil
	end
	
	subservice.onupdatecomplete = nil

	dkcalframework.eventEditorShow = false
end

function onclick_changecolor()

	local nRet = colormenu.TrackColorMenuByFrame( window, this )
	if( nRet ~= -1 ) then 
		
		local strSelectColor = colormenu.cmSelectColor
		local oContentText = document.getElementById( "recurrence_content" )
		oContentText.editTextColor = makedata.BSTRCOLORREF3(strSelectColor)
			
	end
end

function ontimer_query_userinfo()

	if false == login.wechatSubscribe then
		login.CheckUserInfo()
	else
		if g_queryUserInfo ~= nil then
			g_queryUserInfo.killTimer()
			g_queryUserInfo = nil
		end
		document.getElementById( "event_notify_wechat" ).check = true
	end
	
end

function onclick_wechat_subscribe()

	local oWechatNotify = document.getElementById( "event_notify_wechat" )
	if oWechatNotify.check then
		if false == login.IsLogin() then
			sysmenubase.ProcessMenuCmd( 124 )
			oWechatNotify.check = false
		elseif false == login.wechatSubscribe then
			local sAccountHost = configservice.AccountHostByLang
			local sHttp = 'http'
			if configservice.IsAccountHttpsByLang then
				sHttp = 'https'
			end
			local curLang = framework.systemLanguage
			local sUrl = string.format( "%s://%s/api/jump/%s/2003/%s", sHttp, sAccountHost, curLang, login.userToken2 );

			framework.LaunchDefaultBrowser( sUrl );
			oWechatNotify.check = false
			
			if g_queryUserInfo == nil then
				g_queryUserInfo = timer:new()
				g_queryUserInfo.Internal_SetDocument(document)
				g_queryUserInfo.timerLuaFunc = ontimer_query_userinfo
				g_queryUserInfo.setTimer( 3000 )
			end
		end
	end

end


function getRecurrenceType()

	local oComboRecurrence = document.getElementById( "recurrence_combo" )
	local nIndex = oComboRecurrence.GetCurSel()

	local curLang = framework.systemLanguage
	local lunarInvalid = 1
	if curLang == 'chs' or curLang == 'cht' or curLang == 'kor' or curLang == 'jpn' then
		lunarInvalid = 0	
	end

	if nIndex == 0 then
		return 1
	elseif nIndex == 1 then
		return 1
	elseif nIndex == 2 then
		return 5
	elseif nIndex == 3 then
		return 2
	elseif nIndex == 4 then
		return 3
	elseif nIndex == 5 then
		return 6
	elseif nIndex == 6 then
		return 7
	elseif nIndex == 7 then
		return 4
	elseif(nIndex == 8 and lunarInvalid == 0) then
		return 4
	elseif(nIndex == 8 and lunarInvalid == 1) then
		return 8
	elseif(nIndex == 9 and lunarInvalid == 0) then
		return 8
	elseif(nIndex == 9 and lunarInvalid == 1) then
		return 9
	elseif nIndex == 10 then
		return 9
	else 
		return 0
	end
end

function getRecurrenceFreq()
	local oComboRecurrence = document.getElementById( "recurrence_combo" )
	local nIndex = oComboRecurrence.GetCurSel()
	
	local curLang = framework.systemLanguage
	local lunarInvalid = 1
	if curLang == 'chs' or curLang == 'cht' or curLang == 'kor' or curLang == 'jpn' then
		lunarInvalid = 0	
	end

	local strFreq = 'solar'
	if(nIndex == 8 and lunarInvalid == 0) then
		strFreq = 'lunar'
	else 
		strFreq = 'solar'
	end

	return strFreq
end

function getnotifyday()
	
	local oNotifyDay = document.getElementById( "event_notify_day" )
	local nIndex = oNotifyDay.GetCurSel()
	print( nIndex )
	if nIndex == 0 then
		return 0
	elseif nIndex == 1 then
		return -1
	elseif nIndex == 2 then
		return -2
	elseif nIndex == 3 then
		return -3
	else 
		return 0
	end
		
end

function Sleep(n)
   local t0 = os.clock()
   while os.clock() - t0 <= n do end
end

function DelS(str)
	str = str:match("^[%s]*(.-)[%s]*$")
	return str
end

function onclick_saveevent()

	print( "onclick_saveevent" )
	
	local oContent = document.getElementById( "recurrence_content" )
	local strContent = oContent.text
	local strContentTextColor = oContent.editTextColor
	
	strContent = DelS(strContent)
	
	if( string.len( strContent ) == 0 ) then
		strTilte = language.GetStringById( 'IDS_COMMON_MSG_CAPTION_PROMPT' )
		strText = language.GetStringById( 'IDS_EVENTEDITOR_RECURRENCE_NOINPUT' )
		dkcalframework.DkcMessageBox( strText, strTilte, 0 )
		return
	end
	
	
	
	local oMakedown = markdown:new()
	oMakedown.mkText = strContent

	oMakedown.mkTextColor = makedata.BSTRCOLORREF3(strContentTextColor)
	local strContentMakedown = oMakedown.MakeMkText()
	
	
	-- Event Object
	local oEditCalEvent = dkcalframework.editControl.editCalEvent
	print( oEditCalEvent )
	
	local strCurDay = oEditCalEvent.curEventDay
	print( strCurDay )
	
	local oDatatime = datetime:new()
	oDatatime.ParamDateTime( strCurDay )
	
	local oStartDateTime = eventservice.GetEventStartDate( strUnionId )
	
	
	local oComboCustomCount = document.getElementById( "custom_count_combo" )
	local oComboRecurrenceTime = document.getElementById( "recurrence_time_combo" )
	local oERTimes = document.getElementById( "edit_recurrencetimes" )
	local oSETime = document.getElementById( "select_end_time" )
	local oEComplete = document.getElementById( "event_completed" )
	local oNotification = document.getElementById( "event_notification" )
	local oSubsEvent = document.getElementById( "subs_event" )
	local oSubsEventCombo = document.getElementById( "subs_event_combo" )
	
	
	

	if string.len(oERTimes.text) > 0 then
		if( tonumber( oERTimes.text ) < 1 ) then
			strTilte = language.GetStringById( 'IDS_COMMON_MSG_CAPTION_PROMPT' )
			strText = language.GetStringById( 'IDS_EVENTEDITOR_RECURRENCE_ZERO' )
			dkcalframework.DkcMessageBox( strText, strTilte, 0 )
			return
		end
	end
	
	
	local nType = getRecurrenceType()
	
	local strFreq = getRecurrenceFreq()
	
	if string.len(oSETime.name) > 0 then
		local oTmpDatatime = datetime:new()
		oTmpDatatime.ParamDateTime( oSETime.name )
		local oDate = oDatatime
		print( 'oDate' )
		if oStartDateTime ~= nil then
			print( 'null oStartDateTime' )
			oDate = oStartDateTime
		end
		
		if oDate.MoreThanDateTime( oTmpDatatime ) then 
			strTilte = language.GetStringById( 'IDS_COMMON_MSG_CAPTION_PROMPT' )
			strText = language.GetStringById( 'IDS_EVENTEDITOR_ENDTIME_FAIL' )
			dkcalframework.DkcMessageBox( strText, strTilte, 0 )
			return
		end

		if nType == 6 then
			local oNearest = eventservice.GetEventNearestStartDate( oDate, 1, 6 )
			if oNearest.MoreThanDateTime( oTmpDatatime ) then 
				strTilte = language.GetStringById( 'IDS_COMMON_MSG_CAPTION_PROMPT' )
				strText = language.GetStringById( 'IDS_EVENTEDITOR_ENDTIME_MONTHLASTDAY_FAIL' )
				dkcalframework.DkcMessageBox( strText, strTilte, 0 )
				return
			end
		end
	end
	

	
	local nCount = -1
	local strUntil = ''
	if( oComboRecurrenceTime.GetCurSel() == 2 ) then
		if string.len(oERTimes.text) > 0 then
			nCount = tonumber( oERTimes.text )
		end
	elseif( oComboRecurrenceTime.GetCurSel() == 1 ) then 
		if string.len(oSETime.name) > 0 then
			strUntil = oSETime.name
		end
	end
	
	
	local nCustomCount = 0
	if nType == 8 or nType == 9 then
		nCustomCount = oComboCustomCount.GetCurSel() + 1
	end
	
	local oReferrdata = document.referrerData
	if oReferrdata ~= nil and string.len(oReferrdata.GetStr( "unionid" )) > 0 then
	
		print( "Update Item" )
		strUnionId = oReferrdata.GetStr( "unionid" )
		
	
		oEventItem = eventitem:new()
		oEventItem.unionId = strUnionId
		oEventItem.content = oMakedown
		oEventItem.freq = strFreq
		oEventItem.recurrenceCount = nCount
		oEventItem.recurrenceUntil = strUntil
		oEventItem.curDate = oDatatime
		oEventItem.markComplete = oEComplete.check
		oEventItem.customCount = nCustomCount
		
		
		oEventItem.publishSubsId = ""
		if oSubsEvent.check then
			
			local selectItem = oSubsEventCombo.GetSelItem()
			if selectItem ~= nil then 
				oEventItem.publishSubsId = selectItem.data.GetStr("smid")
			end
		
		end
		
		
		
		if oNotification.check then
			oNotifyItem = notifyitem:new()
			oEventItem.checkNotify = true
			oNotifyItem.notifyTime = string.format("%d:%s:%s", getnotifyday(), document.getElementById( "event_notify_hour" ).comboText, document.getElementById( "event_notify_minute" ).comboText ) 
			oNotifyItem.notifyWechat = document.getElementById( "event_notify_wechat" ).check
			oEventItem.notifyObj = oNotifyItem
		end
		
				
		-- update to logic
		eventservice.UpdateRecurrence2( strUnionId, strContentMakedown, oStartDateTime, nType, oEventItem )
		
		-- update to ui
		dkcalframework.editControl.editCalEvent.UpdateEventItem( oEventItem )
		
	else

		print( "Add Item" )

		oEventItem = eventitem:new()
		oEventItem.content = oMakedown
		oEventItem.freq = strFreq
		oEventItem.recurrenceCount = nCount
		oEventItem.recurrenceUntil = strUntil
		oEventItem.curDate = oDatatime
		oEventItem.markComplete = oEComplete.check
		oEventItem.customCount = nCustomCount
		
		if oSubsEvent.check then
			oEventItem.publishSubsId = oSubsEventCombo.GetSelItem().data.GetStr("smid")
		else
			oEventItem.publishSubsId = ""
		end
				
		if oNotification.check then
			oNotifyItem = notifyitem:new()
			oEventItem.checkNotify = true
			oNotifyItem.notifyTime = string.format("%d:%s:%s", getnotifyday(), document.getElementById( "event_notify_hour" ).comboText, document.getElementById( "event_notify_minute" ).comboText ) 
			oNotifyItem.notifyWechat = document.getElementById( "event_notify_wechat" ).check
			oEventItem.notifyObj = oNotifyItem
		end
		

		-- add to logic
		strUnionId = eventservice.AddRecurrence2( strContentMakedown, oDatatime, nType, oEventItem )

		oEventItem.unionId = strUnionId
		
		
		-- add to ui
		dkcalframework.editControl.editCalEvent.AddCalEventItem( oEventItem )
		dkcalframework.editControl.AfterAddEventItem( oEventItem )
	
	end
	
	
	if document.getElementById( "event_notify_wechat" ).check then
		if login.IsVipUser() == false then 
			local oRetData = framework.window.showModelessDialog3( 'dkcalconfig:\\frame.xml|EventNeedUpgrade', xdata:new() )
			if oRetData ~= nil then
				local nRet = oRetData.GetInt('upgrade')
				if nRet == 1 then
					if login.IsLogin() then
						loginmenu.ProcessMenuCmd( 505 )
					else
						sysmenubase.ProcessMenuCmd( 124 )
					end
					
					dkcalframework.editControl.CloseEditForce()
				end
			end
		end
	end

	window.close()
	

end
 
function onclick_selectdate()

	local oSETime = document.getElementById( "select_end_time" )
	local selectdate = selectdate:new();
	
	
	local oEditCalEvent = dkcalframework.editControl.editCalEvent
	local strCurDay = oEditCalEvent.curEventDay
	selectdate.defaultDate = strCurDay
	
	if selectdate.selectDateDoModal()  then 
	
		oSETime.text = getDateTextByLang( selectdate.selectDate )
		oSETime.name = string.format( "%s 23:59:59", selectdate.selectDate )
		
		oSETime.Invalidate()
	end
	
end


function onclick_event_completed()

	resetEditMarkComplete()
	
	if document.getElementById( "event_completed" ).check then
		dkcalframework.PlayDoneTone()
	end
end


function onclick_subs_event()

	local oSubsEvent = document.getElementById( "subs_event" )
	if oSubsEvent.check then
		subservice.UpdateSubsCreateList()
	
		--document.getElementById( "subs_event_combo" ).style.display = ''
		document.getElementById( "subs_event_create" ).style.display = ''
	else
		
		document.getElementById( "subs_event_combo" ).style.display = 'none'
		document.getElementById( "subs_event_create" ).style.display = 'none'
	
	end
	
	
	local oSubsContainer = document.getElementById( "subs_event_container" )
	oSubsContainer.LayoutSelf()
	window.Invalidate()
	
end

function onclick_createsubs()

	oncallback_subs_data()
	
	local serviceHost = dkcalframework.GetApiAccountHost()
	local url = string.format( "%s/api/jump/%s/2006/%s", serviceHost, framework.systemLanguage, login.userToken )
	
	framework.LaunchDefaultBrowser( url )
	
end

function oncallback_subs_data()
	
	local oSubsEventCombo = document.getElementById( "subs_event_combo" )
	
	
	oSubsEventCombo.ResetContent()
	
	
	local oSubsCreateList = subservice.GetSubsCreateList()
	
	if oSubsCreateList.GetCount() == 0 then
		
		oSubsEventCombo.style.display = 'none'
		
	else 
		
		oSubsEventCombo.style.display = ''
		
		for i=0, oSubsCreateList.GetCount()-1 do
			local oData = oSubsCreateList.GetData(i)
			
			local oNewItem = comboboxitem:new()
			oNewItem.text = oData.GetStr("sname")
			oNewItem.data = oData
			oSubsEventCombo.AddItem( oNewItem )
		end
		
		if oSubsCreateList.GetCount() > 0 then
			oSubsEventCombo.SetCurSel(0)
		end
	
	end 
	
	local oSubsContainer = document.getElementById( "subs_event_container" )
	oSubsContainer.LayoutSelf()
	window.Invalidate()
end

function onselect_recurrence_combo()

	local oComboRecurrence = document.getElementById( "recurrence_combo" )
	local nIndex = oComboRecurrence.GetCurSel()
					
	local oComboRecurrenceTime = document.getElementById( "recurrence_time_combo" )
	local oRETimes = document.getElementById( "edit_recurrencetimes" )
	local oSETime = document.getElementById( "select_end_time" )

	if nIndex == 0 then
		oSETime.style.display = 'none'
		oSETime.text = language.GetStringById( 'IDS_EVENTEDITOR_RECURRENCE_INTERVAL' )

		oRETimes.style.display = ''
		oRETimes.disabled = 'true'
		oRETimes.text = '1'
		oComboRecurrenceTime.SetCurSel(2)
		oComboRecurrenceTime.disabled = 'true'
	else 
		oRETimes.disabled = 'false'
		oComboRecurrenceTime.disabled = 'false'
	end


	local nType = getRecurrenceType()
	local oComboCustomCount = document.getElementById( "custom_count_combo" )

	if nType == 8 or nType == 9 then
		oComboCustomCount.style.display = ''
	else
		oComboCustomCount.style.display = 'none'
	end

	local oEditrContainer = document.getElementById( "editor_container" )
	oEditrContainer.LayoutSelf()
	oEditrContainer.Invalidate()

	local oEditrContainer1 = document.getElementById( "editor_container1" )
	oEditrContainer1.LayoutSelf()
	oEditrContainer1.Invalidate()

end


function onselect_recurrence_time_combo()

	local oComboRecurrenceTime = document.getElementById( "recurrence_time_combo" )
	local nIndex = oComboRecurrenceTime.GetCurSel()
					
	local oSETime = document.getElementById( "select_end_time" )
	local oRETimes = document.getElementById( "edit_recurrencetimes" )

	print( string.format("%s %d", 'onselect_recurrence_time_combo', nIndex ) )

	if nIndex == 0 then
		oRETimes.style.display = 'none'
		--oSETime.style.display = 'none'
	elseif nIndex == 1 then
		oRETimes.style.display = 'none'
		oSETime.style.display = ''
	elseif nIndex == 2 then
		oSETime.style.display = 'none'
		oSETime.text = language.GetStringById( 'IDS_EVENTEDITOR_RECURRENCE_INTERVAL' )
		oRETimes.style.display = ''
	else
		print( 'onselect_recurrence_time_combo error' )
	end

	local oEditrContainer1 = document.getElementById( "editor_container1" )
	oEditrContainer1.LayoutSelf()
	oEditrContainer1.Invalidate()

end

function onmouseover_recurrencetimes()

	if this.disabled == false then
		this.style.cssText = "borderColor:0xBD8728"
		this.Invalidate()
	end
	print( "onmouseover_searchitem" )
		
end

function onmouseout_recurrencetimes()

	if this.disabled == false then
		this.style.cssText = "borderColor:0x888888"
		this.Invalidate()
	end

	print( "onmouseout_searchitem" )

end
